/* main function for applying the GA to the portfolio problems
   @author	Hyun Kim
   @date	11/20/99
*/

#define _TEST_MAIN
#ifdef _TEST_MAIN

#include "Population.hpp"
#include "Parameter.hpp"
#include <iostream.h>
#include <iomanip.h>

#define MAXGEN 150		// number of max generation

int main()
{
	// open input/ouput files
	ifstream infile( "input22.txt", ios::in );			// for reading the parameters
	ofstream outfile( "output3-6.txt", ios::out );		// for writing the output
	ofstream detailfile( "detail3-6.txt", ios::out );	// for writing the detail info
	ofstream analfile( "anal3-6.txt", ios::out );
	if ( !infile || !outfile || !detailfile || !analfile )
	{
		cerr << "***ERROR: File Not Opened" << endl;
	}
	readParameters( infile );
	printParameters( outfile );

	// applying the genetic method
	Population* tmppop = new Population;
	Population* pop = new Population;

	pop->initialize();
	report( detailfile, 0, pop );
	analyze( analfile, 0, pop );
	for ( int i = 0; i < MAXGEN; i++ )
	{
		//*tmppop = pop->reproduce();
		*tmppop = pop->reproduceWithReplacement();
		*pop = *tmppop;
		report( detailfile, i + 1, pop );
		analyze( analfile, i + 1, pop );
	}
	cout << pop->getMaxIndex() << endl;
	analyze( analfile, MAXGEN, pop );
	result( outfile, pop );
	delete pop;
	delete tmppop;

	infile.close();
	outfile.close();
	detailfile.close();

	return 0;
}
#endif
